// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v3.21.9
// source: com/ruijc/qingniao/protocol/send.proto

package protocol

import (
	context "context"
	send "gitlab.com/ruijc/qingniao/core/send"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	Send_Code_FullMethodName          = "/com.ruijc.qingniao.protocol.Send/Code"
	Send_Notice_FullMethodName        = "/com.ruijc.qingniao.protocol.Send/Notice"
	Send_Advertisement_FullMethodName = "/com.ruijc.qingniao.protocol.Send/Advertisement"
)

// SendClient is the client API for Send service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SendClient interface {
	// 验证码
	Code(ctx context.Context, in *send.CodeReq, opts ...grpc.CallOption) (*send.Response, error)
	// 通知
	Notice(ctx context.Context, in *send.NoticeReq, opts ...grpc.CallOption) (*send.Response, error)
	// 广告
	Advertisement(ctx context.Context, in *send.AdvertisementReq, opts ...grpc.CallOption) (*send.Response, error)
}

type sendClient struct {
	cc grpc.ClientConnInterface
}

func NewSendClient(cc grpc.ClientConnInterface) SendClient {
	return &sendClient{cc}
}

func (c *sendClient) Code(ctx context.Context, in *send.CodeReq, opts ...grpc.CallOption) (*send.Response, error) {
	out := new(send.Response)
	err := c.cc.Invoke(ctx, Send_Code_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sendClient) Notice(ctx context.Context, in *send.NoticeReq, opts ...grpc.CallOption) (*send.Response, error) {
	out := new(send.Response)
	err := c.cc.Invoke(ctx, Send_Notice_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sendClient) Advertisement(ctx context.Context, in *send.AdvertisementReq, opts ...grpc.CallOption) (*send.Response, error) {
	out := new(send.Response)
	err := c.cc.Invoke(ctx, Send_Advertisement_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SendServer is the server API for Send service.
// All implementations must embed UnimplementedSendServer
// for forward compatibility
type SendServer interface {
	// 验证码
	Code(context.Context, *send.CodeReq) (*send.Response, error)
	// 通知
	Notice(context.Context, *send.NoticeReq) (*send.Response, error)
	// 广告
	Advertisement(context.Context, *send.AdvertisementReq) (*send.Response, error)
	mustEmbedUnimplementedSendServer()
}

// UnimplementedSendServer must be embedded to have forward compatible implementations.
type UnimplementedSendServer struct {
}

func (UnimplementedSendServer) Code(context.Context, *send.CodeReq) (*send.Response, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Code not implemented")
}
func (UnimplementedSendServer) Notice(context.Context, *send.NoticeReq) (*send.Response, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Notice not implemented")
}
func (UnimplementedSendServer) Advertisement(context.Context, *send.AdvertisementReq) (*send.Response, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Advertisement not implemented")
}
func (UnimplementedSendServer) mustEmbedUnimplementedSendServer() {}

// UnsafeSendServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SendServer will
// result in compilation errors.
type UnsafeSendServer interface {
	mustEmbedUnimplementedSendServer()
}

func RegisterSendServer(s grpc.ServiceRegistrar, srv SendServer) {
	s.RegisterService(&Send_ServiceDesc, srv)
}

func _Send_Code_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(send.CodeReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SendServer).Code(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Send_Code_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SendServer).Code(ctx, req.(*send.CodeReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Send_Notice_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(send.NoticeReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SendServer).Notice(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Send_Notice_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SendServer).Notice(ctx, req.(*send.NoticeReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Send_Advertisement_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(send.AdvertisementReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SendServer).Advertisement(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Send_Advertisement_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SendServer).Advertisement(ctx, req.(*send.AdvertisementReq))
	}
	return interceptor(ctx, in, info, handler)
}

// Send_ServiceDesc is the grpc.ServiceDesc for Send service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Send_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.ruijc.qingniao.protocol.Send",
	HandlerType: (*SendServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Code",
			Handler:    _Send_Code_Handler,
		},
		{
			MethodName: "Notice",
			Handler:    _Send_Notice_Handler,
		},
		{
			MethodName: "Advertisement",
			Handler:    _Send_Advertisement_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "com/ruijc/qingniao/protocol/send.proto",
}
